using System.Text.Json;
using System.Text.Json.Serialization;

namespace View_by_Distance.Rename.Models;

public record AppSettings(string Company,
                          string DefaultUnknownDirectoryName,
                          bool ForceIdName,
                          int MaxDegreeOfParallelism,
                          int MaxMinutesDelta,
                          bool RenameUndo)
{

    public override string ToString()
    {
        string result = JsonSerializer.Serialize(this, AppSettingsSourceGenerationContext.Default.AppSettings);
        return result;
    }

}

[JsonSourceGenerationOptions(WriteIndented = true)]
[JsonSerializable(typeof(AppSettings))]
internal partial class AppSettingsSourceGenerationContext : JsonSerializerContext
{
}