using System.Text.Json;
using System.Text.Json.Serialization;

namespace View_by_Distance.Shared.Models;

public record ExifDirectory(AviDirectory AviDirectory,
                            ExifDirectoryBase ExifDirectoryBase,
                            string File,
                            FileMetadataDirectory FileMetadataDirectory,
                            GifHeaderDirectory GifHeaderDirectory,
                            GpsDirectory GpsDirectory,
                            int? Height,
                            string JsonFile,
                            JpegDirectory JpegDirectory,
                            PhotoshopDirectory PhotoshopDirectory,
                            PngDirectory PngDirectory,
                            QuickTimeMovieHeaderDirectory QuickTimeMovieHeaderDirectory,
                            QuickTimeTrackHeaderDirectory QuickTimeTrackHeaderDirectory,
                            WebPDirectory WebPDirectory,
                            int? Width)
{

    public override string ToString()
    {
        string result = JsonSerializer.Serialize(this, ExifDirectorySourceGenerationContext.Default.ExifDirectory);
        return result;
    }

}

[JsonSourceGenerationOptions(WriteIndented = true)]
[JsonSerializable(typeof(ExifDirectory))]
public partial class ExifDirectorySourceGenerationContext : JsonSerializerContext
{
}